//
//  SemiPageCell.m
//  PageContainerPlay
//
//  Created by Caylan Larson on 2/21/15.
//  Copyright (c) 2015 Semireg Industries. All rights reserved.
//

#import "SemiPageCell.h"

@interface SemiPageCell () <UITableViewDataSource, UITableViewDelegate>
@property (strong, nonatomic) UITableView *tableView;
@end

@implementation SemiPageCell

/*
// Only override drawRect: if you perform custom drawing.
// An empty implementation adversely affects performance during animation.
- (void)drawRect:(CGRect)rect {
    // Drawing code
}
*/

-(instancetype)init
{
    self = [super init];
    if(!self)
        return nil;
    
    self.tableView = [UITableView new];
    self.tableView.delegate = self;
    self.tableView.dataSource = self;
    
    [self addSubview:self.tableView];
    
    NSArray* gestures = [NSArray arrayWithArray:self.gestureRecognizers];
    for(UIGestureRecognizer* gesture in gestures)
    {
        [self removeGestureRecognizer:gesture];
    }
    
    return self;
}

-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    return 2;
}

-(void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    NSLog(@"%s %@", __PRETTY_FUNCTION__, indexPath);
}

-(UITableViewCell*)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    UITableViewCell *cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:@"Foo"];
    cell.textLabel.text = @"Foo";
    return cell;
}

-(void)cellLocationInViewportChanged:(CGPoint)location
{
    if(self.delegate)
    {
        [self.delegate pageCell:self centerChanged:[self centerLocation:location.x]];
    }
}

-(CGFloat)centerLocation:(CGFloat)val
{
    if(val >= .5)
    {
        val = 1 - val;
    }
    
    if(val <= .5)
    {
        val = val/.5;
    }
    
    return val;
}

-(void)setupSize:(CGSize)size
{
    self.tableView.frame = CGRectMake(0, 0, size.width, size.height);
}

@end
